#include<iostream>
#include<stdlib.h>
#include<vector>
#include<algorithm>
using namespace std;
int main()
{
	int t;
	scanf("%d",&t);
	int res[6];
	for(int i=0;i<t;i++)
	{
		int n,m;
		int prov = 1;
		long long min_raz=1;
		scanf("%d",&n);
		scanf("%d",&m);
		vector<long long> a;
		vector<long long> b;
		for(int j=0;j<n;j++)
		{
			long long pom;
			scanf("%lld",&pom);
			a.push_back(pom);
		}
			
		for(int j=0;j<m;j++)
		{
			long long pom;
			scanf("%lld",&pom);
			b.push_back(pom);
		}
		sort(a.begin(),a.end());
		for(int j=0;j<n-1;j++)
			{
				if(a[j+1]-a[j]<min_raz || j==0)
				{
					min_raz = a[j+1]-a[j];
				}
			}
		for(int j=0;j<n-1;j++)
			{
				if((a[j+1]-a[j])%min_raz!=0)
				{
					prov=0;
					break;
				}
			}
		for(int j=0;j<m;j++)
			{
				if((a[0]-b[j])%min_raz==0)
				{
					prov=0;
					break;
				}
			}
		res[i]=prov;
	}
	for(int i=0;i<t;i++)
		printf("%d \n", res[i]);
	return 0;
}